part of '../export.dart';

extension Wave2<A, B> on Tuple2<Wave<A>, Wave<B>> {
  Tuple3<Wave<A>, Wave<B>, Wave<Z>> and<Z>(Wave<Z> other)
  => Tuple3(value1, value2, other);

  Wave<Z> latest<Z>(Z Function(A, B) map)
  => Wave.combineLatest2(value1, value2, map);
}

extension Wave3<A, B, C> on Tuple3<Wave<A>, Wave<B>, Wave<C>> {
  Tuple4<Wave<A>, Wave<B>, Wave<C>, Wave<Z>> and<Z>(Wave<Z> other)
  => Tuple4(value1, value2, value3, other);

  Wave<Z> latest<Z>(Z Function(A, B, C) map)
  => Wave.combineLatest3(value1, value2, value3, map);
}

extension Wave4<A, B, C, D> on Tuple4<Wave<A>, Wave<B>, Wave<C>, Wave<D>> {
  Tuple5<Wave<A>, Wave<B>, Wave<C>, Wave<D>, Wave<Z>> and<Z>(Wave<Z> other)
  => Tuple5(value1, value2, value3, value4, other);

  Wave<Z> latest<Z>(Z Function(A, B, C, D) map)
  => Wave.combineLatest4(value1, value2, value3, value4, map);
}

extension Wave5<A, B, C, D, E> on Tuple5<Wave<A>, Wave<B>, Wave<C>, Wave<D>, Wave<E>> {
  Tuple6<Wave<A>, Wave<B>, Wave<C>, Wave<D>, Wave<E>, Wave<Z>> and<Z>(Wave<Z> other)
  => Tuple6(value1, value2, value3, value4, value5, other);

  Wave<Z> latest<Z>(Z Function(A, B, C, D, E) map)
  => Wave.combineLatest5(value1, value2, value3, value4, value5, map);
}

extension Wave6<A, B, C, D, E, F> on Tuple6<Wave<A>, Wave<B>, Wave<C>, Wave<D>, Wave<E>, Wave<F>> {
  Tuple7<Wave<A>, Wave<B>, Wave<C>, Wave<D>, Wave<E>, Wave<F>, Wave<Z>> and<Z>(Wave<Z> other)
  => Tuple7(value1, value2, value3, value4, value5, value6, other);

  Wave<Z> latest<Z>(Z Function(A, B, C, D, E, F) map)
  => Wave.combineLatest6(value1, value2, value3, value4, value5, value6, map);
}

extension Wave7<A, B, C, D, E, F, G> on Tuple7<Wave<A>, Wave<B>, Wave<C>, Wave<D>, Wave<E>, Wave<F>, Wave<G>> {
  Tuple8<Wave<A>, Wave<B>, Wave<C>, Wave<D>, Wave<E>, Wave<F>, Wave<G>, Wave<Z>> and<Z>(Wave<Z> other)
  => Tuple8(value1, value2, value3, value4, value5, value6, value7, other);

  Wave<Z> latest<Z>(Z Function(A, B, C, D, E, F, G) map)
  => Wave.combineLatest7(value1, value2, value3, value4, value5, value6, value7, map);
}

extension Wave8<A, B, C, D, E, F, G, H> on Tuple8<Wave<A>, Wave<B>, Wave<C>, Wave<D>, Wave<E>, Wave<F>, Wave<G>, Wave<H>> {
  Tuple9<Wave<A>, Wave<B>, Wave<C>, Wave<D>, Wave<E>, Wave<F>, Wave<G>, Wave<H>, Wave<Z>> and<Z>(Wave<Z> other)
  => Tuple9(value1, value2, value3, value4, value5, value6, value7, value8, other);

  Wave<Z> latest<Z>(Z Function(A, B, C, D, E, F, G, H) map)
  => Wave.combineLatest8(value1, value2, value3, value4, value5, value6, value7, value8, map);
}

extension Wave9<A, B, C, D, E, F, G, H, I> on Tuple9<Wave<A>, Wave<B>, Wave<C>, Wave<D>, Wave<E>, Wave<F>, Wave<G>, Wave<H>, Wave<I>> {
  Tuple10<Wave<A>, Wave<B>, Wave<C>, Wave<D>, Wave<E>, Wave<F>, Wave<G>, Wave<H>, Wave<I>, Wave<Z>> and<Z>(Wave<Z> other)
  => Tuple10(value1, value2, value3, value4, value5, value6, value7, value8, value9, other);

  Wave<Z> latest<Z>(Z Function(A, B, C, D, E, F, G, H, I) map)
  => Wave.combineLatest9(value1, value2, value3, value4, value5, value6, value7, value8, value9, map);
}

extension Wave10<A, B, C, D, E, F, G, H, I, J> on Tuple10<Wave<A>, Wave<B>, Wave<C>, Wave<D>, Wave<E>, Wave<F>, Wave<G>, Wave<H>, Wave<I>, Wave<J>> {
  Tuple11<Wave<A>, Wave<B>, Wave<C>, Wave<D>, Wave<E>, Wave<F>, Wave<G>, Wave<H>, Wave<I>, Wave<J>, Wave<Z>> and<Z>(Wave<Z> other)
  => Tuple11(value1, value2, value3, value4, value5, value6, value7, value8, value9, value10, other);

  Wave<Z> latest<Z>(Z Function(A, B, C, D, E, F, G, H, I, J) map)
  => Wave.combineLatest10(value1, value2, value3, value4, value5, value6, value7, value8, value9, value10, map);
}

extension Wave11<A, B, C, D, E, F, G, H, I, J, K> on Tuple11<Wave<A>, Wave<B>, Wave<C>, Wave<D>, Wave<E>, Wave<F>, Wave<G>, Wave<H>, Wave<I>, Wave<J>, Wave<K>> {
  Tuple12<Wave<A>, Wave<B>, Wave<C>, Wave<D>, Wave<E>, Wave<F>, Wave<G>, Wave<H>, Wave<I>, Wave<J>, Wave<K>, Wave<Z>> and<Z>(Wave<Z> other)
  => Tuple12(value1, value2, value3, value4, value5, value6, value7, value8, value9, value10, value11, other);

  Wave<Z> latest<Z>(Z Function(A, B, C, D, E, F, G, H, I, J, K) map)
  => Wave.combineLatest11(value1, value2, value3, value4, value5, value6, value7, value8, value9, value10, value11, map);
}

extension Wave12<A, B, C, D, E, F, G, H, I, J, K, L> on Tuple12<Wave<A>, Wave<B>, Wave<C>, Wave<D>, Wave<E>, Wave<F>, Wave<G>, Wave<H>, Wave<I>, Wave<J>, Wave<K>, Wave<L>> {
  Tuple13<Wave<A>, Wave<B>, Wave<C>, Wave<D>, Wave<E>, Wave<F>, Wave<G>, Wave<H>, Wave<I>, Wave<J>, Wave<K>, Wave<L>, Wave<Z>> and<Z>(Wave<Z> other)
  => Tuple13(value1, value2, value3, value4, value5, value6, value7, value8, value9, value10, value11, value12, other);

  Wave<Z> latest<Z>(Z Function(A, B, C, D, E, F, G, H, I, J, K, L) map)
  => Wave.combineLatest12(value1, value2, value3, value4, value5, value6, value7, value8, value9, value10, value11, value12, map);
}

extension Wave13<A, B, C, D, E, F, G, H, I, J, K, L, M> on Tuple13<Wave<A>, Wave<B>, Wave<C>, Wave<D>, Wave<E>, Wave<F>, Wave<G>, Wave<H>, Wave<I>, Wave<J>, Wave<K>, Wave<L>, Wave<M>> {
  Tuple14<Wave<A>, Wave<B>, Wave<C>, Wave<D>, Wave<E>, Wave<F>, Wave<G>, Wave<H>, Wave<I>, Wave<J>, Wave<K>, Wave<L>, Wave<M>, Wave<Z>> and<Z>(Wave<Z> other)
  => Tuple14(value1, value2, value3, value4, value5, value6, value7, value8, value9, value10, value11, value12, value13, other);

  Wave<Z> latest<Z>(Z Function(A, B, C, D, E, F, G, H, I, J, K, L, M) map)
  => Wave.combineLatest13(value1, value2, value3, value4, value5, value6, value7, value8, value9, value10, value11, value12, value13, map);
}

extension Wave14<A, B, C, D, E, F, G, H, I, J, K, L, M, N> on Tuple14<Wave<A>, Wave<B>, Wave<C>, Wave<D>, Wave<E>, Wave<F>, Wave<G>, Wave<H>, Wave<I>, Wave<J>, Wave<K>, Wave<L>, Wave<M>, Wave<N>> {
  Tuple15<Wave<A>, Wave<B>, Wave<C>, Wave<D>, Wave<E>, Wave<F>, Wave<G>, Wave<H>, Wave<I>, Wave<J>, Wave<K>, Wave<L>, Wave<M>, Wave<N>, Wave<Z>> and<Z>(Wave<Z> other)
  => Tuple15(value1, value2, value3, value4, value5, value6, value7, value8, value9, value10, value11, value12, value13, value14, other);

  Wave<Z> latest<Z>(Z Function(A, B, C, D, E, F, G, H, I, J, K, L, M, N) map)
  => Wave.combineLatest14(value1, value2, value3, value4, value5, value6, value7, value8, value9, value10, value11, value12, value13, value14, map);
}

extension Wave15<A, B, C, D, E, F, G, H, I, J, K, L, M, N, O> on Tuple15<Wave<A>, Wave<B>, Wave<C>, Wave<D>, Wave<E>, Wave<F>, Wave<G>, Wave<H>, Wave<I>, Wave<J>, Wave<K>, Wave<L>, Wave<M>, Wave<N>, Wave<O>> {
  Tuple16<Wave<A>, Wave<B>, Wave<C>, Wave<D>, Wave<E>, Wave<F>, Wave<G>, Wave<H>, Wave<I>, Wave<J>, Wave<K>, Wave<L>, Wave<M>, Wave<N>, Wave<O>, Wave<Z>> and<Z>(Wave<Z> other)
  => Tuple16(value1, value2, value3, value4, value5, value6, value7, value8, value9, value10, value11, value12, value13, value14, value15, other);

  Wave<Z> latest<Z>(Z Function(A, B, C, D, E, F, G, H, I, J, K, L, M, N, O) map)
  => Wave.combineLatest15(value1, value2, value3, value4, value5, value6, value7, value8, value9, value10, value11, value12, value13, value14, value15, map);
}

extension Wave16<A, B, C, D, E, F, G, H, I, J, K, L, M, N, O, P> on Tuple16<Wave<A>, Wave<B>, Wave<C>, Wave<D>, Wave<E>, Wave<F>, Wave<G>, Wave<H>, Wave<I>, Wave<J>, Wave<K>, Wave<L>, Wave<M>, Wave<N>, Wave<O>, Wave<P>> {
  Tuple17<Wave<A>, Wave<B>, Wave<C>, Wave<D>, Wave<E>, Wave<F>, Wave<G>, Wave<H>, Wave<I>, Wave<J>, Wave<K>, Wave<L>, Wave<M>, Wave<N>, Wave<O>, Wave<P>, Wave<Z>> and<Z>(Wave<Z> other)
  => Tuple17(value1, value2, value3, value4, value5, value6, value7, value8, value9, value10, value11, value12, value13, value14, value15, value16, other);

  Wave<Z> latest<Z>(Z Function(A, B, C, D, E, F, G, H, I, J, K, L, M, N, O, P) map)
  => Wave.combineLatest16(value1, value2, value3, value4, value5, value6, value7, value8, value9, value10, value11, value12, value13, value14, value15, value16, map);
}

extension Wave17<A, B, C, D, E, F, G, H, I, J, K, L, M, N, O, P, Q> on Tuple17<Wave<A>, Wave<B>, Wave<C>, Wave<D>, Wave<E>, Wave<F>, Wave<G>, Wave<H>, Wave<I>, Wave<J>, Wave<K>, Wave<L>, Wave<M>, Wave<N>, Wave<O>, Wave<P>, Wave<Q>> {
  Tuple18<Wave<A>, Wave<B>, Wave<C>, Wave<D>, Wave<E>, Wave<F>, Wave<G>, Wave<H>, Wave<I>, Wave<J>, Wave<K>, Wave<L>, Wave<M>, Wave<N>, Wave<O>, Wave<P>, Wave<Q>, Wave<Z>> and<Z>(Wave<Z> other)
  => Tuple18(value1, value2, value3, value4, value5, value6, value7, value8, value9, value10, value11, value12, value13, value14, value15, value16, value17, other);

  Wave<Z> latest<Z>(Z Function(A, B, C, D, E, F, G, H, I, J, K, L, M, N, O, P, Q) map)
  => Wave.combineLatest17(value1, value2, value3, value4, value5, value6, value7, value8, value9, value10, value11, value12, value13, value14, value15, value16, value17, map);
}

extension Wave18<A, B, C, D, E, F, G, H, I, J, K, L, M, N, O, P, Q, R> on Tuple18<Wave<A>, Wave<B>, Wave<C>, Wave<D>, Wave<E>, Wave<F>, Wave<G>, Wave<H>, Wave<I>, Wave<J>, Wave<K>, Wave<L>, Wave<M>, Wave<N>, Wave<O>, Wave<P>, Wave<Q>, Wave<R>> {
  Tuple19<Wave<A>, Wave<B>, Wave<C>, Wave<D>, Wave<E>, Wave<F>, Wave<G>, Wave<H>, Wave<I>, Wave<J>, Wave<K>, Wave<L>, Wave<M>, Wave<N>, Wave<O>, Wave<P>, Wave<Q>, Wave<R>, Wave<Z>> and<Z>(Wave<Z> other)
  => Tuple19(value1, value2, value3, value4, value5, value6, value7, value8, value9, value10, value11, value12, value13, value14, value15, value16, value17, value18, other);

  Wave<Z> latest<Z>(Z Function(A, B, C, D, E, F, G, H, I, J, K, L, M, N, O, P, Q, R) map)
  => Wave.combineLatest18(value1, value2, value3, value4, value5, value6, value7, value8, value9, value10, value11, value12, value13, value14, value15, value16, value17, value18, map);
}

extension Wave19<A, B, C, D, E, F, G, H, I, J, K, L, M, N, O, P, Q, R, S> on Tuple19<Wave<A>, Wave<B>, Wave<C>, Wave<D>, Wave<E>, Wave<F>, Wave<G>, Wave<H>, Wave<I>, Wave<J>, Wave<K>, Wave<L>, Wave<M>, Wave<N>, Wave<O>, Wave<P>, Wave<Q>, Wave<R>, Wave<S>> {
  Tuple20<Wave<A>, Wave<B>, Wave<C>, Wave<D>, Wave<E>, Wave<F>, Wave<G>, Wave<H>, Wave<I>, Wave<J>, Wave<K>, Wave<L>, Wave<M>, Wave<N>, Wave<O>, Wave<P>, Wave<Q>, Wave<R>, Wave<S>, Wave<Z>> and<Z>(Wave<Z> other)
  => Tuple20(value1, value2, value3, value4, value5, value6, value7, value8, value9, value10, value11, value12, value13, value14, value15, value16, value17, value18, value19, other);

  Wave<Z> latest<Z>(Z Function(A, B, C, D, E, F, G, H, I, J, K, L, M, N, O, P, Q, R, S) map)
  => Wave.combineLatest19(value1, value2, value3, value4, value5, value6, value7, value8, value9, value10, value11, value12, value13, value14, value15, value16, value17, value18, value19, map);
}

extension Wave20<A, B, C, D, E, F, G, H, I, J, K, L, M, N, O, P, Q, R, S, T> on Tuple20<Wave<A>, Wave<B>, Wave<C>, Wave<D>, Wave<E>, Wave<F>, Wave<G>, Wave<H>, Wave<I>, Wave<J>, Wave<K>, Wave<L>, Wave<M>, Wave<N>, Wave<O>, Wave<P>, Wave<Q>, Wave<R>, Wave<S>, Wave<T>> {
  Wave<Z> latest<Z>(Z Function(A, B, C, D, E, F, G, H, I, J, K, L, M, N, O, P, Q, R, S, T) map)
  => Wave.combineLatest20(value1, value2, value3, value4, value5, value6, value7, value8, value9, value10, value11, value12, value13, value14, value15, value16, value17, value18, value19, value20, map);
}