part of '../export.dart';

class ActiveLens<S, T> extends Lens<S, T> {
  final S Function() _sget;
  final void Function(S) _sset;

  const ActiveLens.raw(this._sget, this._sset, T Function(S) retrieve,
      S Function(S, T) transform) : super(retrieve, transform);

  ActiveLens.rawLens(this._sget, this._sset, Lens<S, T> lens)
      : super(lens.get, lens.update);

  @override
  ActiveLens<S, Q> then<Q>(Lens<T, Q> lens) {
    return ActiveLens.rawLens(_sget, _sset, super.then(lens));
  }

  ActiveLens<T, Q> chain<Q>(Lens<T, Q> lens) {
    return ActiveLens.rawLens(() => get(_sget()),
            (a) => update(_sget(), a), lens);
  }

  void put(T t) => _sset(update(_sget(), t));
}

class SeaLens<S, T> extends ActiveLens<S, T> {
  final Sea<S> sourceSea;

  SeaLens.raw(this.sourceSea, T Function(S) retrieve,
      S Function(S, T) transform) : super.raw(() => sourceSea.value,
      sourceSea.add, retrieve, transform);

  SeaLens.rawLens(this.sourceSea, Lens<S, T> lens)
      : super.raw(() => sourceSea.value,
      sourceSea.add, lens.get, lens.update);

  @override
  SeaLens<S, Q> then<Q>(Lens<T, Q> lens) {
    return SeaLens.rawLens(sourceSea, super.then(lens));
  }

  @override
  SeaLens<T, Q> chain<Q>(Lens<T, Q> lens) {
    return SeaLens.rawLens(sourceSea.transform(this), lens);
  }
}