import 'package:bird/signal_wave.dart';
import 'package:dartz/dartz.dart';

extension OptionWave<T> on Wave<Option<T>> {

  static Wave<Option<T>> upcast2<T>(Wave<Option<T>> a, Wave<Option<T>> b) {
    return a.and(b).latest((Option<T> a, Option<T> b) {
      return a.fold(() => b.fold(() => None<T>(), some), some);
    });
  }

  Wave<Option<U>> oMap<U>(U Function(T) m) {
    return this.map((a) => a.map(m));
  }

  Wave<bool> isSome() => map((a) => a.isSome());
}
