import 'package:bird/signal_wave.dart';

extension BoolWave on Wave<bool> {
  Wave<T> ifTrueThen<T>(T Function() t, {T Function() orElse}) =>
      map((a) => a ? t() : orElse?.call());

  Wave<bool> not() => map((a) => !a);

  Wave<bool> or(Wave<bool> wave) =>
      this.and(wave).latest((bool a, bool b) => a || b);

  Wave<bool> andBool(Wave<bool> wave) =>
      this.and(wave).latest((bool a, bool b) => a && b);

  Wave<bool> operator |(Wave<bool> wave) => or(wave);

  Wave<bool> operator &(Wave<bool> wave) => andBool(wave);
}
