import 'package:bird/signal_wave.dart';
import 'package:dartz/dartz.dart';
import 'package:decimal/decimal.dart';

extension StringWave on Wave<String> {
  static Wave<String> join(Iterable<Wave<String>> list) {
    return Wave.combineLatest(list, (a) => a.join());
  }

  Wave<int> length() {
    return map((a) => a.length);
  }

  Wave<bool> startsWith(Pattern pattern) {
    return map((a) => a.startsWith(pattern));
  }

  Wave<bool> isNotNullNotEmpty() {
    return map((a) => a != null && a.isNotEmpty);
  }

  Wave<Option<Decimal>> asDecimalOptional() {
    return map(Decimal.tryParse).map(optionOf);
  }
}
